{{ Prop Serial}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ
  'TV : "tv_text"
  Num : "Numbers"
  Ext : "Extended_FDSerial_128ByteBuffers"
  'Ext : "Extended_FDSerial"

VAR
  'ATTENTION bytearrays used with ExtendedFD_Serial have to have the same size
  'as the constant MaxStrLength in the File Extended_FDSerial_128ByteBuffers !
  'you can access the value of this constant by objectname#constantname
  'in THIS example the objectname is "Ext" so it is "Ext#MaxStrLength"
  'the stringreceive-functions fill up the bytearray with zeros in a length
  'of MaxStrLength !. If the bytearray is smaller than MaxStrLength other
  'things get overwritten by zeros !  
  Byte MyStr [Ext#MaxStrLength]
  long Torque


PUB Main

  Num.init
  'TV. start(12)
  'TV.str(string("Start",13))
  'TV.out(13)
  'Ext.start (17,16,0,9600)
  Ext.start (31,30,0,9600)
  {Ext.SetDelimiter (13)}
  'repeat 30

  repeat 
    Ext.rxflush
    {Ext.str(string("-0.148 INLB,"))} ' I can transmit this string and recieve it. This is what is expected from my serial device.
    'Torque := Ext.RxStrTime (200,@MyStr)
    Ext.Str(string("R"))
    Ext.RxStrTime (500,@MyStr)
    Ext.Str(@MyStr)
    Ext.Tx(13)
    waitcnt (clkfreq * 1 + cnt)

    {
    TV.str(@MyStr)
    TV.out (13)
    waitcnt (clkfreq/10 + cnt)
    TV.str(string("End",13))
    Ext.stop
    }

{ the lines below are Scripting-code for Br@ys-Terminal-Software
program TestSendingAString;

const STRING1 = 'first test';
const SensorAnswerTemplate = 'mmmbsdddddbuuuuu';

const SensorAnswerExample = 'FF1A -123.4 uuuuu';

var 
  i : longint;

begin
  writeln(STRING1);
  comsendstr(STRING1);
    while not(i=27) do // repeat until ESC
    begin
      while i <> ord('R') do i:=ComReadChr();// wait for char "R" 
      begin
        i:=0;
        writeln('received a R');
        writeln('send back ')
        writeln(SensorAnswerExample);
        
        comsendstr(SensorAnswerExample);
        comsendchr(10);
        comsendchr(13);

        writeln('wait for R');
      end
    end;
end.
}
    